//+------------------------------------------------------------------+
//|                                       Bollinger _Stochastic .mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "samir arman Copyright 2013,"
#property link      "samir_arman@yahoo.com"
extern double Lot1=0.1;
extern bool Auto_Lots=false;
extern double  MaxRisk = 0.01;     
extern int  TakeProfit=30;
extern int StopLoss=30;
extern int TrailingStop=0;
extern int BreakEven=0;
extern string Bollinger="---------------------------";
extern int  period=20;
extern int  deviation=2;
extern int  bands_shift=0;
extern string Apply_price="0 CLOSE, 1 OPEN,2 HIGH,3 LOW ";
extern int Apply=0;
extern string Stochastic="---------------------------";
extern int  Kperiod=5;
extern int  Dperiod=3;
extern int  slowing=3;
extern string method_1="0 SMA, 1 EMA,2 SMMA,3 LWMA ";
extern int  method=0;
extern string F="-----------------------";
extern bool  Close_At_Next = TRUE;
extern string Time_Start="10:00";
extern string Time_End="23:59"; 
extern bool Multiplication=true;
extern string Multiplication_info = "0=1,2,3,4....    1=1,2,3,5,8....    2=1,2,4,8,16....    3=1,3,9,27....";
extern int Multiplication_Mode = 2;
extern int step=10;
extern int MagicNumber=708;
string T;double pr; color clr;
int movestopto=1;
 int TrailingStep=0;
 double OrderStop,Lots,OrderStops,Lotss;
 
double pt;
string nam;
int init()
  {
if(Digits==5||Digits==4) 
{ 
pt=0.0001; 
} 
else{ 
pt=0.01; 
}
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
double hour=Hour()+Minute()/100.0;
  datetime start= StrToTime(TimeToStr(TimeCurrent(), TIME_DATE) + " " + Time_Start);
  datetime end= StrToTime(TimeToStr(TimeCurrent(), TIME_DATE) + " " + Time_End);
  bool time=(Time[0]>=start && Time[0]<=end); 
  bool end_time=(Time[0]>=end); 
  
   double Bo=iBands(NULL,0,period,deviation,bands_shift,Apply,MODE_MAIN,1);
 double Bo_Buy=iBands(NULL,0,period,deviation,bands_shift,Apply,MODE_LOWER,1);
 double Bo_Sell=iBands(NULL,0,period,deviation,bands_shift,Apply,MODE_UPPER,1);
  
  
  double  Stoc_1 =iStochastic(Symbol(),0,Kperiod,Dperiod,slowing,method,0,0,1);

  double  Stoc_2 =iStochastic(Symbol(),0,Kperiod,Dperiod,slowing,method,0,1,1);
  
  
  
  
  Comment(Stoc_1,"   ",Stoc_2);//pofetH()>=0&&High[0]>=Bo_Sell&&
  if(pofetH()>=0&&High[1]>=Bo_Sell&&Stoc_1<Stoc_2&&Stoc_2<80&&Stoc_2>50&&ordestotal1_2(OP_BUY)==0&&ordestotal1_2(OP_SELL)==0){ 
    open(OP_SELL,Lots(MaxRisk),Bid,TakeProfit,StopLoss) ;
    
  }
  
  
  //pofetH()>=0&&Low[0]<=Bo_Buy&&
  
if(pofetH()>=0&&Low[1]<=Bo_Buy&&Stoc_1>Stoc_2&&Stoc_2<50&&Stoc_2>20&&ordestotal1_2(OP_BUY)==0&&ordestotal1_2(OP_SELL)==0){  

   open(OP_BUY,Lots(MaxRisk),Ask,TakeProfit,StopLoss) ;
   
         }
         
         
    for(int B=0;B<OrdersHistoryTotal();B++){
if(OrderSelect(B,SELECT_BY_POS,MODE_HISTORY))
 if(OrderMagicNumber()==MagicNumber&&OrderSymbol()==Symbol()&&OrderType()==OP_BUY){
  OrderStop = OrderStopLoss();   Lots=OrderLots();
}
}



for(int s=0;s<OrdersHistoryTotal();s++){
if(OrderSelect(s,SELECT_BY_POS,MODE_HISTORY))
 if(OrderMagicNumber()==MagicNumber&&OrderSymbol()==Symbol()&&OrderType()==OP_SELL){
  OrderStops = OrderStopLoss();   Lotss=OrderLots();
}
}






   if(Multiplication==true){




if(pofetH()<0&&typeopen()==OP_SELL&&ordestotal1_2(OP_SELL)==0){
 open(OP_SELL,Lotss*Multiplication_Mode,OrderStops,TakeProfit,StopLoss) ;
}









if(pofetH()<0&&typeopen()==OP_BUY&&ordestotal1_2(OP_BUY)==0){
 open(OP_BUY,Lots*Multiplication_Mode,OrderStop,TakeProfit,StopLoss) ;
}


}
  

  
  
    
 if(TrailingStop>0)MoveTrailingStop();
   if(BreakEven>0)MoveBreakEven();
  
  if(pofetH()>=0&&Low[1]<=Bo_Buy&&Stoc_1>Stoc_2&&Stoc_2<50&&Stoc_2>20&&Close_At_Next==true)closeordar(OP_SELL);


  if(pofetH()>=0&&High[1]>=Bo_Sell&&Stoc_1<Stoc_2&&Stoc_2<80&&Stoc_2>50&&Close_At_Next==true)closeordar(OP_BUY);

  
   return(0);
  }
//+------------------------------------------------------------------+
int open(int ty,double lot,double prc,int pof,int sll)
   {
     double sl=0,tp=0;
    
     bool modi;
     
     if(ty==OP_BUY || ty==OP_BUYSTOP || ty==OP_BUYLIMIT)
        {
         if(sll>0){sl=prc-(sll*pt);}else{sl=0;}
         if(pof>0){tp=prc+(pof*pt);}else{tp=0;}
         clr=Green;
         T="Ask ";
         pr=NormalizeDouble(Ask,Digits);
        }
     if(ty==OP_SELL || ty==OP_SELLSTOP || ty==OP_SELLLIMIT)
       { 
         if(sll>0){sl=prc+(sll*pt);}else{sl=0;}
         if(pof>0){tp=prc-(pof*pt);}else{tp=0;}
         clr=Red;
         T="Bid";
         pr=NormalizeDouble(Bid,Digits);
       }     
         int tik=OrderSend(Symbol()
                ,ty
                ,lot
                ,NormalizeDouble(prc,Digits)
                ,10
                ,0
                ,0
                ,"samir"
                ,MagicNumber
                ,0
                ,clr);
          string t;
            if(ty==OP_BUY)t="BUY";if(ty==OP_SELL)t="SELL";if(ty==OP_BUYSTOP)t="BUY STOP";if(ty==OP_SELLSTOP)t="SELL STOP";if(ty==OP_BUYLIMIT)t="BUY LIMIT";if(ty==OP_SELLLIMIT)t="SELL LIMIT";
      if(tik>0)
         {
          if(tp>0 || sl>0)modi=OrderModify(tik,prc,NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),0,CLR_NONE);   else modi=true;
          if(!modi){Print("Modify Err#= ",GetLastError(),"   ",Symbol()," ",Period(),"   Open Price= ",DoubleToStr(prc,Digits),"   SL= ",DoubleToStr(sl,Digits),"   Tp= ",DoubleToStr(tp,Digits));} 
           Print("Order Opened successfully   " ,"Type   ",t,"  LotSize   ",lot,"  Price   ",DoubleToStr(prc,Digits),"  TP   ",DoubleToStr(tp,Digits),"  SL   ",DoubleToStr(sl,Digits));
         }
         else
           {
            Print("OrderSend failed with error #",GetLastError(), " Type ",t,"   LotSize= ",lot,"   ",T,"Now= ",DoubleToStr(pr,Digits),"   Price= ",DoubleToStr(prc,Digits),"   TP= ",DoubleToStr(tp,Digits),"   SL= ",DoubleToStr(sl,Digits),"   Spread= ",MarketInfo(Symbol(),MODE_SPREAD));
           }
                //////
         return(tik);
   
}    
 void MoveTrailingStop()
{
   
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(TrailingStop>0&&NormalizeDouble(Ask-TrailingStep*pt,Digits)>NormalizeDouble(OrderOpenPrice()+TrailingStop*pt,Digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Bid-TrailingStop*pt,Digits))||(OrderStopLoss()==0))
               {
                  bool k=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailingStop*pt,Digits),OrderTakeProfit(),0,Blue);
                
               }
            }
         }
         else 
         {
            if(TrailingStop>0&&NormalizeDouble(Bid+TrailingStep*pt,Digits)<NormalizeDouble(OrderOpenPrice()-TrailingStop*pt,Digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)>(NormalizeDouble(Ask+TrailingStop*pt,Digits)))||(OrderStopLoss()==0))
               {
                  bool j=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailingStop*pt,Digits),OrderTakeProfit(),0,Red);
                
               }
            }
         }
      }
   }
}



void MoveBreakEven()
{
   int cnt,total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(BreakEven>0)
            {
               if(NormalizeDouble((Bid-OrderOpenPrice()),Digits)>BreakEven*pt)
               {
                  if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),Digits)<0)
                  {
                     bool t=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+movestopto*pt,Digits),OrderTakeProfit(),0,Blue);
                  
                  }
               }
            }
         }
         else
         {
            if(BreakEven>0)
            {
               if(NormalizeDouble((OrderOpenPrice()-Ask),Digits)>BreakEven*pt)
               {
                  if(NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),Digits)<0)
                  {
                     bool o=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-movestopto*pt,Digits),OrderTakeProfit(),0,Red);
               
                  }
               }
            }
         }
      }
   }
}

 
   int ordestotal1_2(int type) 
{ 
int total_2=0; 
for(int b=0;b<OrdersTotal();b++){ 
if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES)) 
if(OrderSymbol()==Symbol()&&MagicNumber==OrderMagicNumber()&&OrderType()==type){ 
total_2++; 
} 
} 
return(total_2); 
} 

 bool CloseDeleteAll()
{
    int total  = OrdersTotal();
      for (int cnt = total-1 ; cnt >=0 ; cnt--)
      {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
       
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) 
         {
         if(OrderSymbol()==Symbol()&&MagicNumber==OrderMagicNumber()){
            switch(OrderType())
            {
               case OP_BUY       :
               {
                  if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),0,Violet))
                     return(false);
               }break;                  
               case OP_SELL      :
               {
                  if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),0,Violet))
                     return(false);
               }break;
            }             
         
            
            if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP || OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT)
               if(!OrderDelete(OrderTicket()))
               { 
                  Print("Error deleting " + OrderType() + " order : ",GetLastError());
                  return (false);
             }  }
          }
      }
      return (true);
}
  double Lots(double risk)
   {
    double Lot;
    if(Auto_Lots)
       { 
        if(risk>1)risk=1;
        //_________________________________________________________________________________________
        double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);
        double Max_Lot = MarketInfo(Symbol(), MODE_MAXLOT);
        double lot_step= MarketInfo(Symbol(), MODE_LOTSTEP);
        Lot=NormalizeDouble(AccountBalance()*risk/100/10,2);
        Lot=NormalizeDouble(Lot,2);
        Lot=NormalizeDouble(Lot/lot_step,0)*lot_step;
        if (Lot < Min_Lot) Lot = Min_Lot; 
        if (Lot > Max_Lot) Lot = Max_Lot;
        //_________________________________________________________________________________________
       }
      else Lot=Lot1;
    return(Lot);
   }
   ////////////////////////////////////////////
      

 
  double pofet(){
 
 double pr1=0;
 for(int p=0;p<OrdersTotal();p++){
 if(OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
 if(OrderSymbol()==Symbol()&&MagicNumber==OrderMagicNumber()){
 pr1=pr1+OrderProfit();
}
 }return(pr1);
 }
 
 
 
  double pofetH(){
 
 double pr1=0;
 for(int p=0;p<OrdersHistoryTotal();p++){
 if(OrderSelect(p,SELECT_BY_POS,MODE_HISTORY))
 if(OrderSymbol()==Symbol()&&MagicNumber==OrderMagicNumber()){
 pr1=OrderProfit();
}
 }return(pr1);
 }
 
  void closeordar(int typer){
 for(int c=0;c<OrdersTotal();c++){
 if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES))
 if(OrderMagicNumber()==MagicNumber&&OrderSymbol()==Symbol()&&OrderType()== typer){
 if(OrderType()==OP_BUY)bool r=OrderClose(OrderTicket(),OrderLots(),Bid,30);
 if(OrderType()==OP_SELL)bool e=OrderClose(OrderTicket(),OrderLots(),Ask,30);
 RefreshRates();
    }
   }
  }
   int typeopen(){
int type;
for(int l=0;l<OrdersHistoryTotal();l++){
 if(OrderSelect(l,SELECT_BY_POS,MODE_HISTORY))
 if(OrderMagicNumber()==MagicNumber&&OrderSymbol()==Symbol()){
 type=OrderType();
 }
 }
 return(type);
 } 